package extensions;

import java.io.IOException;
import java.io.StringReader;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import org.xml.sax.InputSource;

import dareka.common.Logger;
import dareka.extensions.Extension2;
import dareka.extensions.ExtensionManager;
import dareka.extensions.RequestFilter;
import dareka.extensions.Rewriter;
import dareka.processor.HttpHeader;
import dareka.processor.HttpRequestHeader;
import dareka.processor.HttpResponseHeader;

/**
 * R~ꗗ̓₷Ă݂B
 */
public class comVideoRewriterExtension implements Extension2, RequestFilter, Rewriter {
	private static final Pattern REWRITER_SUPPORTED_PATTERN = Pattern.compile(
			"^http://com\\.nicovideo\\.jp/video/.*$");
	
	// Extension2 interface
	public void registerExtensions(ExtensionManager mgr) {
		final int REQUIRED_REVISION = 100909;
		if (ExtUtil.REVISION < REQUIRED_REVISION) {
			Logger.warning("comVideoRewriter: ERROR!!! ExtUtil_"+REQUIRED_REVISION+" OR LATER IS REQUIRED.");
		} else {
			mgr.registerRewriter(this);
			mgr.registerRequestFilter(this);
		}
	}
	
	public String getVersionString() {
		return "comVideoRewriterExtension_121212";
	}
	
	// Rewriter interface
	public Pattern getRewriterSupportedURLAsPattern() {
		return REWRITER_SUPPORTED_PATTERN;
	}
	
	HttpRequestHeader httpRequestHeader;
	public int onRequest(HttpRequestHeader requestHeader) throws IOException {
		httpRequestHeader = requestHeader;
		return RequestFilter.OK;
	}
	
	public String onMatch(Matcher match, HttpResponseHeader responseHeader,
			String content) throws IOException {
		ConcurrentHashMap<String, String> getMap = new ConcurrentHashMap<String, String>();
		Pattern p = Pattern.compile("<a class=\"video\" href=\"http://www\\.nicovideo\\.jp/watch/(\\d{10})\"[\\s\\S]+?<p>([\\s\\S]+?)</p>");
		Matcher m = p.matcher(content);
		while(m.find()){
			getMap.put(m.group(1),m.group(2));
		}
		String ids = "";
		for (Map.Entry<String,String> e : getMap.entrySet()) {
			if(!ids.equals("")) ids += ",";
			ids += e.getKey();
		}
		if(ids.equals("")) return content;
		try{
			Document doc = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(new InputSource(new StringReader(ExtUtil.http_get(ExtUtil.setURL(httpRequestHeader, "http://i.nicovideo.jp/v3/video.array", true), "v="+ids))));
			Element root = doc.getDocumentElement();
			NodeList children = root.getChildNodes();
			for( int i=0; i<children.getLength(); i++ ) {
				Node child = children.item(i);
				if( child instanceof Element && child.getNodeName().equals("video_info")){
					ConcurrentHashMap<String, String> newMap = new ConcurrentHashMap<String, String>();
					NodeList children2 = child.getChildNodes();
					for( int i2=0; i2<children2.getLength(); i2++ ) {
						Node child2 = children2.item(i2);
						if( child2 instanceof Element ) {
							if(child2.getNodeName().equals("video")){
								NodeList children3 = child2.getChildNodes();
								for( int i3=0; i3<children3.getLength(); i3++ ) {
									Node child3 = children3.item(i3);
									if( child3 instanceof Element ) {
										if(child3.getNodeName().equals("id")){
											newMap.put("video_id", child3.getTextContent());
										}else if(child3.getNodeName().equals("description")){
											newMap.put("description", child3.getTextContent()
												.replaceAll("(?:sm|nm|so|ca|ax|yo|nl|ig|na|cw|z[a-e]|om|sk|yk)\\d+(?:\\?eco=1)?","<a href=\"http://www.nicovideo.jp/watch/$0\">$0</a>")
												.replaceAll("(?:watch|user|mylist)/\\d+","<a href=\"http://www.nicovideo.jp/$0\">$0</a>")
												.replaceAll("co\\d+","<a href=\"http://com.nicovideo.jp/community/$0\">$0</a>")
												.replaceAll("ch\\d+","<a href=\"http://ch.nicovideo.jp/channel/$0\">$0</a>")
												.replaceAll("lv\\d+","<a href=\"http://live.nicovideo.jp/watch/$0\">$0</a>")
												.replaceAll("(?:sg|mg)\\d+","<a href=\"http://seiga.nicovideo.jp/watch/$0\">$0</a>")
												.replaceAll("im\\d+","<a href=\"http://seiga.nicovideo.jp/seiga/$0\">$0</a>")
												.replaceAll("nc\\d+","<a href=\"http://www.niconicommons.jp/material/$0\">$0</a>")
												.replaceAll("dw\\d+","<a href=\"http://ichiba.nicovideo.jp/item/$0\">$0</a>")
											);
										}else if(child3.getNodeName().equals("option_flag_community")){
											newMap.put("option_flag_community", child3.getTextContent());
										}
									}
								}
							}else if(child2.getNodeName().equals("thread")){
								NodeList children3 = child2.getChildNodes();
								for( int i3=0; i3<children3.getLength(); i3++ ) {
									Node child3 = children3.item(i3);
									if( child3 instanceof Element && child3.getNodeName().equals("id")){
										newMap.put("thread_id", child3.getTextContent());
									}
								}
							}
						}
					}
					String replaceStr = "";
					if(newMap.get("option_flag_community").equals("0")){
						replaceStr += "<a href=\"http://www.nicovideo.jp/watch/"+newMap.get("video_id")+"\">֍s</a><br>";
					}
					replaceStr += newMap.get("description");
					content = content.replace("<p>"+getMap.get(newMap.get("thread_id")), "<p style=\"line-height:normal;\">"+replaceStr);
				}
			}
		}catch(Exception e){
		}
		return content;
	}
}
